1 # Customize maint.mk -*- makefile -*-
2 # Copyright (C) 2003-2023 Free Software Foundation, Inc.
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 3 of the License, or
7 # (at your option) any later version.
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
14 # You should have received a copy of the GNU General Public License
15 # along with this program. If not, see <https://www.gnu.org/licenses/>.
17 # Used in maint.mk's web-manual rule
18 manual_title
= Core GNU utilities
20 # Use the direct link. This is guaranteed to work immediately, while
21 # it can take a while for the faster mirror links to become usable.
22 url_dir_list
= https
://ftp.gnu.org
/gnu
/$(PACKAGE
)
24 # Exclude bundled external projects from syntax checks
25 VC_LIST_ALWAYS_EXCLUDE_REGEX
= src
/blake2
/.
*$$
27 # Tests not to run as part of "make distcheck".
28 local-checks-to-skip
= \
29 sc_proper_name_utf8_requires_ICONV \
32 # Tools used to bootstrap this package, used for "announcement".
33 bootstrap-tools
= autoconf
,automake
,gnulib
,bison
35 # Now that we have better tests, make this the default.
38 # Comparing tarball sizes compressed using different xz presets, we see that
39 # an -8e-compressed tarball is only 9KiB larger than the -9e-compressed one.
40 # Using -8e is preferred, since that lets the decompression process use half
41 # the memory (32MiB rather than 64MiB).
42 # $ for i in {7,8,9}{e,}; do \
43 # (n=$(xz -$i < coreutils-8.15*.tar|wc -c);echo $n $i) & done |sort -nr
52 old_NEWS_hash
= ac6cb1c35890b53e56acbfbb078fcd53
54 # Add an exemption for sc_makefile_at_at_check.
55 _makefile_at_at_check_exceptions
= \
56 ' && !/MAKEINFO/ && !/^cu_install_prog/ && !/dynamic-dep/'
58 # Our help-version script is in a slightly different location.
59 _hv_file ?
= $(srcdir)/tests
/misc
/help-version
61 # Ensure that the list of O_ symbols used to compute O_FULLBLOCK is complete.
62 dd
= $(srcdir)/src
/dd.c
65 @
{ echo O_FULLBLOCK
; echo O_NOCACHE
; \
66 perl
-nle
'/^ +\| (O_\w*)$$/ and print $$1' $(dd
); } |
sort > $@
.1
67 @
{ echo O_NOFOLLOW
; perl
-nle
'/{"[a-z]+",\s*(O_\w+)},/ and print $$1' \
68 $(dd
); } |
sort > $@
.2
69 @diff
-u
$@
.1 $@
.2; diff
=$$?
; \
72 ||
{ echo
'$(ME): $(dd) has inconsistent O_ flag lists'>&2; \
75 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
76 # with the strings from the two affected variables.
77 dd_c
= $(srcdir)/src
/dd.c
79 ifneq ($(wildcard $(dd_c
)),)
80 @len
=$$( (sed
-n
'/conversions\[] =$$/,/^};/p' $(dd_c
);\
81 sed
-n
'/flags\[] =$$/,/^};/p' $(dd_c
) ) \
82 |sed
-n
'/"/s/^[^"]*"\([^"]*\)".*/\1/p'| wc
-L
);\
83 max
=$$(sed
-n
'/^#define LONGEST_SYMBOL /s///p' $(dd_c
) \
84 |tr
-d
'"' | wc
-L
); \
85 if
test "$$len" = "$$max"; then
:; else \
86 echo
'dd.c: LONGEST_SYMBOL is not longest' 1>&2; \
91 # Many m4 macros names once began with 'jm_'.
92 # On 2004-04-13, they were all changed to start with gl_ instead.
93 # Make sure that none are inadvertently reintroduced.
95 @grep
-nE
'jm_[A-Z]' \
96 $$($(VC_LIST
) m4 |grep
'\.m4$$'; echo
/dev
/null
) && \
97 { echo
'$(ME): do not use jm_ in m4 macro names' \
100 # Ensure that each root-requiring test is run via the "check-root" rule.
102 @t1
=sc-root.expected
; t2
=sc-root.actual
; \
103 grep
-nl
'^ *require_root_$$' `$(VC_LIST) tests` | \
104 sed
's|.*/tests/|tests/|' |
sort > $$t1; \
105 for t in
$(all_root_tests
); do echo
$$t; done |
sort > $$t2; \
106 st
=0; diff
-u
$$t1 $$t2 || st
=1; \
110 # Ensure that all version-controlled test cases are listed in $(all_tests).
111 sc_tests_list_consistency
:
113 test_extensions_rx
=`echo $(TEST_EXTENSIONS) \
114 | sed -e "s/ /|/g" -e "s/$$bs./$$bs$$bs./g"`; \
116 for t in
$(all_tests
); do echo
$$t; done
; \
118 $(SHELL
) build-aux
/vc-list-files tests \
119 | grep
-Ev
'^tests/(factor/(run|create-test)|init)\.sh$$' \
120 | grep
-E
"$$test_extensions_rx\$$"; \
121 } |
sort | uniq
-u | grep .
&& exit
1; :
123 # Ensure that all version-controlled test scripts are executable.
125 @set
-o noglob
2>/dev
/null || set
-f
; \
127 find_ext
="-name '' "`printf -- "-o -name *%s " $(TEST_EXTENSIONS)`;\
128 find
$(srcdir)/tests
/ \
( $$find_ext \
) \
! -perm
-u
+x
-print \
129 |
{ sed
"s|^$(srcdir)/||"; git ls-files
$(srcdir)/tests
/; } \
131 | sed
-e
"s/^/$(ME): Please make test executable: /" | grep . \
134 # Ensure all gnulib patches apply cleanly
135 sc_ensure_gl_diffs_apply_cleanly
:
136 @find
$(srcdir)/gl
/ -name
'*.diff' | while read p
; do \
137 patch
--fuzz
=0 -f
-s
-d
$(srcdir)/gnulib
/ -p1
--dry-run
< "$$p" >&2 \
138 ||
{ echo
"$$p" >&2; echo
'To refresh all gl patches run:' \
139 'make refresh-gnulib-patches' >&2; exit
1; } \
142 # Avoid :>file which doesn't propagate errors
143 sc_prohibit_colon_redirection
:
144 @cd
$(srcdir)/tests
&& GIT_PAGER
= git grep
-En
': *>.*\|\|' \
145 && { echo
'$(ME): '"The leading colon in :> will hide errors" >&2; \
149 # Ensure emit_mandatory_arg_note() is called if required
150 sc_ensure_emit_mandatory_arg_note
:
151 @cd
$(srcdir)/src
&& GIT_PAGER
= git \
152 grep
-l
-- '^ *-[^-].*--.*[^[]=' *.c \
153 | xargs grep
-L emit_mandatory_arg_note | grep . \
154 && { echo
'$(ME): '"emit_mandatory_arg_note() missing" 1>&2; \
157 # Create a list of regular expressions matching the names
158 # of files included from system.h. Exclude a couple.
160 @sed
-n
'/^# *include /s///p' $(srcdir)/src
/system.h \
161 | grep
-Ev
'sys/(param|file)\.h' \
162 | sed
's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
167 Exit
() { set
+e
; (exit
$$1); exit
$$1; }; \
168 for sig in
1 2 3 13 15; do \
169 eval
"trap 'Exit $$(expr $$sig + 128)' $$sig"; \
173 # Files in src/ should not include directly any of
174 # the headers already included via system.h.
175 sc_system_h_headers
: .re-list
176 @if
test -f
$(srcdir)/src
/system.h
; then \
177 trap
'rc=$$?; rm -f .re-list; exit $$rc' 0; \
179 grep
-nE
-f .re-list \
180 $$($(VC_LIST_EXCEPT
) | grep
-E
'^($(srcdir)/)?src/') \
181 && { echo
'$(ME): the above are already included via system.h'\
182 1>&2; exit
1; } ||
:; \
185 # Files in src/ should not use '%s' notation in format strings,
186 # i.e., single quotes around %s (or similar) should be avoided.
187 sc_prohibit_quotes_notation
:
188 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-n
"\".*[\`']%s'.*\"" *.c \
189 && { echo
'$(ME): '"Use quote() to avoid quoted '%s' notation" 1>&2; \
193 error_fns
= (error|diagnose
)
195 # Files in src/ should quote all strings in error() output, so that
196 # unexpected input chars like \r etc. don't corrupt the error.
197 # In edge cases this can be avoided by putting the format string
198 # on a separate line to the arguments, or the arguments in parenthesis.
201 && GIT_PAGER
= git grep
-E
-n
'$(error_fns) *\(.*%s.*, [^(]*\);$$' \
202 *.c | grep
-v
', q' \
203 && { echo
'$(ME): '"Use quote() for error string arguments" 1>&2; \
207 # Files in src/ should quote all file names in error() output
208 # using quotef(), to provide quoting only when necessary,
209 # but also provide better support for copy and paste when used.
210 sc_error_shell_quotes
:
211 @cd
$(srcdir)/src
&& \
212 { GIT_PAGER
= git grep
-E \
213 '$(error_fns) \(.*%s[:"], .*(name|file)[^"]*\);$$' *.c
; \
214 GIT_PAGER
= git grep
-E \
215 ' quote[ _].*file' *.c
; } \
216 | grep
-Ev
'(quotef|q[^ ]*name)' \
217 && { echo
'$(ME): '"Use quotef() for colon delimited names" 1>&2; \
221 # Files in src/ should quote all file names in error() output
222 # using quoteaf() when the name is separated with spaces,
223 # to distinguish the file name at issue and
224 # to provide better support for copy and paste.
225 sc_error_shell_always_quotes
:
226 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-E \
227 '$(error_fns) \(.*[^:] %s[ "].*, .*(name|file)[^"]*\);$$' \
228 *.c | grep
-Ev
'(quoteaf|q[^ ]*name)' \
229 && { echo
'$(ME): '"Use quoteaf() for space delimited names" 1>&2; \
232 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-E
-A1 \
233 '$(error_fns) \([^%]*[^:] %s[ "]' *.c | grep
'quotef' \
234 && { echo
'$(ME): '"Use quoteaf() for space delimited names" 1>&2; \
238 # Avoid unstyled quoting to internal slots and thus destined for diagnostics
239 # as that can leak unescaped control characters to the output, when using
240 # the default "literal" quoting style.
241 # Instead use quotef(), or quoteaf() or in edge cases quotearg_n_style_colon().
242 # A more general PCRE would be @prohibit='quotearg_.*(?!(style|buffer))'
243 sc_prohibit-quotearg
:
244 @prohibit
='quotearg(_n)?(|_colon|_char|_mem) ' \
245 in_vc_files
='\.c$$' \
246 halt
='Unstyled diagnostic quoting detected' \
250 @prohibit
='\|\| skip ' \
251 halt
='Use skip_ not skip' \
256 'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
257 $$($(VC_LIST_EXCEPT
)) && \
258 { echo
'$(ME): found misuse of Sun OS version numbers' 1>&2; \
261 # Ensure that the list of programs and author names is accurate.
262 # We need a UTF8 locale. If a lack of locale support or a missing
263 # translation inhibits printing of UTF-8 names, just skip this test.
264 au_dotdot
= authors-dotdot
265 au_actual
= authors-actual
266 sc_check-AUTHORS
: $(all_programs
)
267 @locale
=en_US.UTF-8
; \
268 LC_ALL
=$$locale .
/src
/factor
--version \
269 | grep
' Torbjorn ' > /dev
/null \
270 && { echo
"$@: skipping this check"; exit
0; }; \
271 rm -f
$(au_actual
) $(au_dotdot
); \
272 for i in
`ls $(all_programs) \
273 | sed -e 's,^src/,,' -e 's,$(EXEEXT)$$,,' \
275 | $(ASSORT) -u`; do \
276 test "$$i" = '[' && continue
; \
278 if
test "$$i" = install; then \
280 elif
test "$$i" = test; then \
283 LC_ALL
=$$locale .
/src
/$$exe --version \
284 | perl
-0 -p
-e
's/,\n/, /gm' \
285 | sed
-n
-e
'/Written by /{ s//'"$$i"': /;' \
286 -e
's/,* and /, /; s/\.$$//; p; }'; \
287 done
> $(au_actual
) && \
288 sed
-n
'/^[^ ][^ ]*:/p' $(srcdir)/AUTHORS
> $(au_dotdot
) \
289 && diff
$(au_actual
) $(au_dotdot
) \
290 && rm -f
$(au_actual
) $(au_dotdot
)
292 # Each program with a non-ASCII author name must link with LIBICONV.
293 sc_check-I18N-AUTHORS
:
294 @cd
$(srcdir)/src
&& \
295 for i in
$$(git grep
-l
-w proper_name_utf8
*.c|sed
's/\.c//'); do \
296 grep
-E
"^src_$${i}_LDADD"' .?= .*\$$\(LIBICONV\)' local.mk \
298 ||
{ echo
"$(ME): link rules for $$i do not include" \
299 '$$(LIBICONV)' 1>&2; exit
1; }; \
302 # Disallow the C99 printf size specifiers %z and %j as they're not portable.
303 # The gnulib printf replacement does support them, however the printf
304 # replacement is not currently explicitly depended on by the gnulib error()
305 # module for example. Also we use fprintf() in a few places to output simple
306 # formats but don't use the gnulib module as it is seen as overkill at present.
307 # We'd have to adjust the above gnulib items before disabling this.
308 sc_prohibit-c99-printf-format
:
309 @cd
$(srcdir)/src
&& GIT_PAGER
= git grep
-n
'%[0*]*[jz][udx]' *.c \
310 && { echo
'$(ME): Use PRI*MAX instead of %j or %z' 1>&2; exit
1; } \
313 # Ensure the alternative __attribute (keyword) form isn't used as
314 # that form is not elided where required. Also ensure that we don't
315 # directly use attributes already defined by gnulib.
316 # TODO: move the check for _GL... attributes to gnulib.
317 sc_prohibit-gl-attributes
:
318 @prohibit
='__attribute |__(unused|pure|const)__' \
319 in_vc_files
='\.[ch]$$' \
320 halt
='Use _GL... attribute macros' \
323 # Prefer the const declaration form, with const following the type
324 sc_prohibit-const-char
:
325 @prohibit
='const char \*' \
326 in_vc_files
='\.[ch]$$' \
327 halt
='Use char const *, not const char *' \
330 # Look for lines longer than 80 characters, except omit:
332 # - the fdl.texi file copied from gnulib,
333 # - the help2man script copied from upstream,
334 # - tests involving long checksum lines, and
335 # - the 'pr' test cases.
336 FILTER_LONG_LINES
= \
337 \|^
[^
:]*NEWS
:.
*https\
{,1\
}://| d
; \
338 \|^
[^
:]*doc
/fdl.texi
:| d
; \
339 \|^
[^
:]*man
/help2man
:| d
; \
340 \|^
[^
:]*tests
/cksum
/sha
[0-9]*sum.
*\.pl
[-:]| d
; \
341 \|^
[^
:]*tests
/pr
/|
{ \|^
[^
:]*tests
/pr
/pr-tests
:|
!d
; };
343 @wc
-L
/dev
/null
>/dev
/null
2>/dev
/null \
344 ||
{ echo
"$@: skipping: wc -L not supported"; exit
0; }; \
345 sed
-r
1q
/dev
/null
2>/dev
/null \
346 ||
{ echo
"$@: skipping: sed -r not supported"; exit
0; }; \
347 files
=$$($(VC_LIST_EXCEPT
) | xargs wc
-L | sed
-rn
'/ total$$/d;\
348 s/^ *(8[1-9]|9[0-9]|[0-9]{3,}) //p'); \
349 halt
='line(s) with more than 80 characters; reindent'; \
350 for file in
$$files; do \
351 expand
$$file | grep
-nE
'^.{80}.' | \
352 sed
-e
"s|^|$$file:|" -e
'$(FILTER_LONG_LINES)'; \
353 done | grep .
&& { msg
="$$halt" $(_sc_say_and_exit
) } ||
:
355 # Option descriptions should not start with a capital letter.
356 # One could grep source directly as follows:
357 # grep -E " {2,6}-.*[^.] [A-Z][a-z]" $$($(VC_LIST_EXCEPT) | grep '\.c$$')
358 # but that would miss descriptions not on the same line as the -option.
359 sc_option_desc_uppercase
: $(ALL_MANS
)
360 @grep
'^\\fB\\-' -A1 man
/*.1 | LC_ALL
=C grep
'\.1.[A-Z][a-z]' \
361 && { echo
1>&2 '$@: found initial capitals in --help'; exit
1; } ||
:
363 # '--' should not be treated as '–' (U+2013 EN DASH) in long option names.
364 sc_texi_long_option_escaped
: doc
/coreutils.
info
365 @grep
' –[^ ]' '$<' \
366 && { echo
1>&2 '$@: found unquoted --long-option'; exit
1; } ||
:
368 # Ensure all man/*.[1x] files are present.
369 sc_man_file_correlation
: check-x-vs-1 check-programs-vs-x
371 # Ensure that for each .x file in the 'man/' subdirectory, there is a
372 # corresponding .1 file in the definition of $(EXTRA_MANS).
373 # But since that expansion usually lacks programs like arch and hostname,
374 # add them here manually.
377 @PATH
=.
/src
$(PATH_SEPARATOR
)$$PATH; export PATH
; \
379 (cd
$(srcdir)/man
&& ls
-1 *.x
) \
380 | sed
's/\.x$$//' |
$(ASSORT
) > $$t; \
381 (echo
$(patsubst man
/%,%,$(ALL_MANS
)) \
382 | tr
-s
' ' '\n' | sed
's/\.1$$//') \
383 |
$(ASSORT
) -u | diff
- $$t ||
{ rm $$t; exit
1; }; \
386 # Ensure that non-trivial .x files in the 'man/' subdirectory,
387 # i.e., files exceeding a line count of 20 or a byte count of 1000,
388 # contain a Copyright notice.
389 .PHONY
: sc_man_check_x_copyright
390 sc_man_check_x_copyright
:
392 cd
$(srcdir) && wc
-cl man
/*.x | head
-n-1 \
393 | awk
'$$1 >= 20 || $$2 >= 1000 {print $$3}' \
394 | xargs grep
-L
'Copyright .* Free Software Foundation' \
396 && { echo
1>&2 '$@: exceeding file size/line count limit' \
397 '- please add a copyright note'; status
=1; }; \
400 # Writing a portable rule to generate a manpage like '[.1' would be
401 # a nightmare, so filter that out.
402 all-progs-but-lbracket
= $(filter-out [,$(patsubst src
/%,%,$(all_programs
)))
404 # Ensure that for each coreutils program there is a corresponding
405 # '.x' file in the 'man/' subdirectory.
406 .PHONY
: check-programs-vs-x
409 for p in dummy
$(all-progs-but-lbracket
); do \
410 case
$$p in
*.so
) continue
;; esac
; \
411 test $$p = dummy
&& continue
; \
412 test $$p = ginstall
&& p
=install ||
: ; \
413 test -f
$(srcdir)/man
/$$p.x \
414 ||
{ echo missing
$$p.x
1>&2; status
=1; }; \
418 # Ensure we can check out on case insensitive file systems
419 sc_case_insensitive_file_names
: src
/uniq
420 @git
-C
$(srcdir) ls-files |
sort -f | src
/uniq
-Di | grep .
&& \
421 { echo
"$(ME): the above file(s) conflict on case insensitive" \
422 " file systems" 1>&2; exit
1; } ||
:
424 # Ensure that the end of each release's section is marked by two empty lines.
425 sc_NEWS_two_empty_lines
:
426 @sed
-n
4,/Noteworthy
/p
$(srcdir)/NEWS \
427 | perl
-n0e
'/(^|\n)\n\n\* Noteworthy/ or exit 1' \
428 ||
{ echo
'$(ME): use two empty lines to separate NEWS sections' \
431 # With split lines, don't leave an operator at end of line.
432 # Instead, put it on the following line, where it is more apparent.
433 # Don't bother checking for "*" at end of line, since it provokes
434 # far too many false positives, matching constructs like "TYPE *".
435 # Similarly, omit "=" (initializers).
436 binop_re_ ?
= [-/+^
!<>]|
[-/+*^
!<>=]=|
&&?|\|\|?|
<<=?|
>>=?
437 sc_prohibit_operator_at_end_of_line
:
438 @prohibit
='. ($(binop_re_))$$' \
439 in_vc_files
='\.[chly]$$' \
440 halt
='found operator at end of line' \
443 # Partial substitutes for GNU extensions \< and \> in regexps.
444 begword
= (^|
[^_
[:alnum
:]])
445 endword
= ($$|
[^_
[:alnum
:]])
447 # Don't use address of "stat" or "lstat" functions
448 sc_prohibit_stat_macro_address
:
449 @prohibit
='$(begword)l?stat '':|&l?stat$(endword)' \
450 halt
='stat() and lstat() may be function-like macros' \
453 # Ensure that date's --help output stays in sync with the info
454 # documentation for GNU strftime. The only exception is %N and %q,
455 # which date accepts but GNU strftime does not.
457 # "info foo" fails with error, but not "info foo >/dev/null".
458 extract_char
= sed
's/^[^%][^%]*%\(.\).*/\1/'
460 @if
test -f
$(srcdir)/src
/date.c
; then \
461 if
info libc date calendar format
2>/dev
/null | \
462 grep
"^ *['\`]%.'$$" >$@
-tmp
; then \
463 { echo N
; echo q
; $(extract_char
) $@
-tmp
; }|
sort \
465 grep
'^ %. ' $(srcdir)/src
/date.c |
sort \
466 |
$(extract_char
) > $@
-src
; \
467 diff
-u
$@
-src
$@
-info || exit
1; \
469 echo
'$(ME): skipping $@: libc info not installed' 1>&2; \
471 rm -f
$@
-info $@
-src
$@
-tmp
; \
474 # Indent only with spaces.
475 sc_prohibit_tab_based_indentation
:
477 halt
='TAB in indentation; use only spaces' \
480 # Enforce lowercase 'e' in "I.e.".
481 sc_prohibit_uppercase_id_est
:
483 halt
='Uppercase "Id Est" abbreviation; use "I.e.," instead' \
486 # Enforce double-space before "I.e." at the beginning of a sentence.
487 sc_ensure_dblspace_after_dot_before_id_est
:
488 @prohibit
='\. I\.e\.' \
489 halt
='Single space after dot before "i.e."; use ". i.e." instead' \
492 # Enforce comma after "i.e." (at least before a blank or at EOL).
493 sc_ensure_comma_after_id_est
:
494 @prohibit
='[Ii]\.e\.( |$$)' \
495 halt
='Missing comma after "i.e."; use "i.e.," instead' \
498 # The SEE ALSO section of a man page should not be terminated with
499 # a period. Check the first line after each "SEE ALSO" line in man/*.x:
500 sc_prohibit_man_see_also_period
:
501 @grep
-nB1
'\.$$' $$($(VC_LIST_EXCEPT
) | grep
'man/.*\.x$$') \
502 | grep
-A1
-e
'-\[SEE ALSO]' | grep
'\.$$' && \
503 { echo
'$(ME): do not end "SEE ALSO" section with a period' \
506 sc_prohibit_exit_write_error
:
507 @prohibit
='error.*EXIT_FAILURE.*write error' \
508 in_vc_files
='\.c$$' \
509 halt
='Use write_error() instead' \
513 @prohibit
='$(begword)NULL$(endword)' \
514 in_vc_files
='\.[ch]$$' \
515 halt
='use nullptr instead' \
518 # Don't use "indent-tabs-mode: nil" anymore. No longer needed.
519 sc_prohibit_emacs__indent_tabs_mode__setting
:
520 @prohibit
='^( *[*#] *)?indent-tabs-mode:' \
521 halt
='use of emacs indent-tabs-mode: setting' \
524 # Ensure that tests don't include a redundant fail=0.
526 @prohibit
='$(begword)fail=0$(endword)' \
527 halt
='fail=0 initialization' \
530 # Ensure that tests don't use `cmd ... && fail=1` as that hides crashes.
531 # The "exclude" expression allows common idioms like `test ... && fail=1`
532 # and the 2>... portion allows commands that redirect stderr and so probably
533 # independently check its contents and thus detect any crash messages.
534 sc_prohibit_and_fail_1
:
535 @prohibit
='&& fail=1' \
536 exclude
='(returns_|stat|kill|test |EGREP|grep|compare|2> *[^/])' \
537 halt
='&& fail=1 detected. Please use: returns_ 1 ... || fail=1' \
538 in_vc_files
='^tests/' \
541 # Ensure that tests don't use `cmd ... || fail` as that's a noop.
543 @prohibit
='\|\| fail$$' \
545 halt
='|| fail detected. Please use: || fail=1' \
546 in_vc_files
='^tests/' \
549 # Ensure that env vars are not passed through returns_ as
550 # that was seen to fail on FreeBSD /bin/sh at least
551 sc_prohibit_env_returns
:
552 @prohibit
='=[^ ]* returns_ ' \
553 exclude
='_ returns_ ' \
554 halt
='Passing env vars to returns_ is non portable' \
555 in_vc_files
='^tests/' \
558 # The mode part of a setfacl -m option argument must be three bytes long.
559 # I.e., an argument of user:bin:rw or user:bin:r will make Solaris 10's
560 # setfacl reject it with: "Unrecognized character found in mode field".
561 # Use hyphens to give it a length of 3: "...:rw-" or "...:r--".
562 sc_prohibit_short_facl_mode_spec
:
563 @prohibit
='$(begword)setfacl .*-m.*:.*:[rwx-]{1,2} ' \
564 halt
='setfacl mode string length < 3; extend with hyphen(s)' \
567 # Ensure that "stdio--.h" is used where appropriate.
568 sc_require_stdio_safer
:
569 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.[ch]$$' > /dev
/null
; then \
570 files
=$$(grep
-El
'$(begword)freopen ?\(' $$($(VC_LIST_EXCEPT
)\
571 | grep
'\.[ch]$$')); \
572 test -n
"$$files" && grep
-LE
'include "stdio--.h"' $$files \
574 { echo
'$(ME): the above files should use "stdio--.h"' \
575 1>&2; exit
1; } ||
:; \
579 # Ensure that "stdlib--.h" is used where appropriate.
580 sc_require_stdlib_safer
:
581 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.[ch]$$' > /dev
/null
; then \
582 files
=$$(grep
-El
'$(begword)mkstemp ?\(' $$($(VC_LIST_EXCEPT
)\
583 | grep
'\.[ch]$$')); \
584 test -n
"$$files" && grep
-LE
'include "stdlib--.h"' $$files \
586 { echo
'$(ME): the above files should use "stdlib--.h"' \
587 1>&2; exit
1; } ||
:; \
591 sc_prohibit_perl_hash_quotes
:
592 @prohibit
="\{'[A-Z_]+' *[=}]" \
593 halt
="in Perl code, write \$$hash{KEY}, not \$$hash{'K''EY'}" \
596 # Prefer xnanosleep over other less-precise sleep methods
598 @prohibit
='$(begword)(nano|u)?sleep \(' \
599 halt
='prefer xnanosleep over other sleep interfaces' \
602 # Use print_ver_ (from init.cfg), not open-coded $VERBOSE check.
603 sc_prohibit_verbose_version
:
604 @prohibit
='test "\$$VERBOSE" = yes && .* --version' \
605 halt
='use the print_ver_ function instead...' \
608 # Enforce print_ver_ tracking of dependencies
609 # Each coreutils specific program a test requires
610 # should be tagged by calling through env(1).
611 sc_env_test_dependencies
:
612 @cd
$(top_srcdir
) && GIT_PAGER
= git grep
-E \
613 "env ($$(build-aux/gen-lists-of-programs.sh --list-progs | \
614 grep -vF '[' |paste -d'|' -s))" tests | \
615 sed
"s/\([^:]\):.*env \([^)' ]*\).*/\1 \2/" | uniq | \
616 while read
test prog
; do \
617 printf
'%s' $$test | grep
'\.pl$$' >/dev
/null
&& continue
; \
618 grep
"print_ver_.* $$prog" $$test >/dev
/null \
619 || echo
$$test should call
: print_ver_
$$prog; \
620 done | grep .
&& exit
1 ||
:
622 # Use framework_failure_, not the old name without the trailing underscore.
623 sc_prohibit_framework_failure
:
624 @prohibit
='$(begword)framework_''failure$(endword)' \
625 halt
='use framework_failure_ instead' \
628 # Prohibit the use of `...` in tests/. Use $(...) instead.
629 sc_prohibit_test_backticks
:
630 @prohibit
='`' in_vc_files
='^tests/' \
631 halt
='use $$(...), not `...` in tests/' \
634 # Ensure that compare is used to check empty files
635 # so that the unexpected contents are displayed
636 sc_prohibit_test_empty
:
637 @prohibit
='test -s.*&&' in_vc_files
='^tests/' \
638 halt
='use `compare /dev/null ...`, not `test -s ...` in tests/' \
641 # Programs like sort, ls, expr use PROG_FAILURE in place of EXIT_FAILURE.
642 # Others, use the EXIT_CANCELED, EXIT_ENOENT, etc. macros defined in system.h.
643 # In those programs, ensure that EXIT_FAILURE is not used by mistake.
644 sc_some_programs_must_avoid_exit_failure
:
646 && grep
-nw EXIT_FAILURE \
647 $$(git grep
-El
'[^T]_FAILURE|EXIT_CANCELED' src
/) \
648 | grep
-v
'^src/system\.h:' \
649 | grep
-vE
'= EXIT_FAILURE|return .* \?' | grep . \
650 && { echo
'$(ME): do not use EXIT_FAILURE in the above' \
653 # Ensure that tests call the get_min_ulimit_v_ function if using ulimit -v
654 sc_prohibit_test_ulimit_without_require_
:
655 @
(git
-C
$(srcdir) grep
-l get_min_ulimit_v_ tests
; \
656 git
-C
$(srcdir) grep
-l
'ulimit -v' tests
) \
657 |
sort | uniq
-u | grep .
&& { echo
"$(ME): the above test(s)"\
658 " should match get_min_ulimit_v_ with ulimit -v" 1>&2; exit
1; } ||
:
660 # Ensure that tests call the cleanup_ function if using background processes
661 sc_prohibit_test_background_without_cleanup_
:
662 @
(git
-C
$(srcdir) grep
-El
'( &$$|&[^&]*=\$$!)' tests
; \
663 git
-C
$(srcdir) grep
-l
'cleanup_()' tests | sed p
) \
664 |
sort | uniq
-u | grep .
&& { echo
"$(ME): the above test(s)"\
665 " should use cleanup_ for background processes" 1>&2; exit
1; } ||
:
667 # Ensure that tests call the print_ver_ function for programs which are
668 # actually used in that test.
669 sc_prohibit_test_calls_print_ver_with_irrelevant_argument
:
670 @git
-C
$(srcdir) grep
-w print_ver_ tests \
671 | sed
's#:print_ver_##' \
673 while read file name
; do \
674 for i in
$$name; do \
675 case
"$$i" in
install) i
=ginstall
;; esac
; \
676 grep
-w
"$$i" $$file|grep
-vw print_ver_|grep .
>/dev
/null \
678 echo
"*** Test: $$file, offending: $$i." 1>&2; };\
681 test $$fail = 0 || exit
1; \
682 } ||
{ echo
"$(ME): the above test(s) call print_ver_ for" \
683 "program(s) they don't use" 1>&2; exit
1; }
685 # Exempt the contents of any usage function from the following.
686 _continued_string_col_1
= \
687 s
/^usage .
*?
\n}//ms
;/\\\n\w
/ and
print ("$$ARGV\n"),$$e=1;END
{$$e||
=0;exit
$$e}
688 # Ding any source file that has a continued string with an alphabetic in the
689 # first column of the following line. We prohibit them because they usually
690 # trigger false positives in tools that try to map an arbitrary line number
691 # to the enclosing function name. Of course, very many strings do precisely
692 # this, *when they are part of the usage function*. That is why we exempt
693 # the contents of any function named "usage".
694 sc_prohibit_continued_string_alpha_in_column_1
:
695 @perl
-0777 -ne
'$(_continued_string_col_1)' \
696 $$($(VC_LIST_EXCEPT
) | grep
'\.[ch]$$') \
697 ||
{ echo
'$(ME): continued string with word in first column' \
699 # Use this to list offending lines:
700 # git ls-files |grep '\.[ch]$' | xargs \
701 # perl -n -0777 -e 's/^usage.*?\n}//ms;/\\\n\w/ and print "$ARGV\n"' \
702 # | xargs grep -A1 '\\$'|grep '\.[ch][:-][_a-zA-Z]'
705 ###########################################################
706 _p0
= \
([^
"'/]\|"\
([^
\"]\|
[\
].\
)*"\|'\([^\']\|[\].\)*'
707 _pre = $(_p0)\|[/][^"'/*]\|[/]"\([^\"]\|[\].\)*"\|[/]'\
([^
\']\|
[\
].\
)*'\)*
708 _pre_anchored = ^\($(_pre)\)
709 _comment_and_close = [^*]\|[*][^/*]\)*[*][*]*/
710 # help font-lock mode: '
712 # A sed expression that removes ANSI C and ISO C99 comments.
713 # Derived from the one in GNU gettext's 'moopp' preprocessor.
714 _sed_remove_comments
= \
718 s
,$(_pre_anchored
)//.
*,\
1,; \
720 s
,$(_pre_anchored
)/[*]\
($(_comment_and_close
),\
1 ,; \
723 s
,$(_pre_anchored
)/[*].
*,\
1 ,; \
727 s
,^\
($(_comment_and_close
),,; \
735 # Quote all single quotes.
736 _sed_rm_comments_q
= $(subst ','\'',$(_sed_remove_comments))
737 # help font-lock mode: '
739 _space_before_paren_exempt
=?
\\n
\\$$
740 _space_before_paren_exempt
= \
741 (^
*\
#|\\n\\$$|%s\(to %s|(date|group|character)\(s\))
742 # Ensure that there is a space before each open parenthesis in C code.
743 sc_space_before_open_paren
:
744 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.[ch]$$' > /dev
/null
; then \
746 for c in
$$($(VC_LIST_EXCEPT
) | grep
'\.[ch]$$'); do \
747 sed
'$(_sed_rm_comments_q)' $$c 2>/dev
/null \
748 | grep
-i
'[[:alnum:]](' \
749 | grep
-vE
'$(_space_before_paren_exempt)' \
750 | grep .
&& { fail
=1; echo
"*** $$c"; }; \
753 { echo
'$(ME): the above files lack a space-before-open-paren' \
754 1>&2; exit
1; } ||
:; \
758 # Similar to the gnulib maint.mk rule for sc_prohibit_strcmp
759 # Use STREQ_LEN or STRPREFIX rather than comparing strncmp == 0, or != 0.
761 @prohibit
='^[^#].*str''ncmp *\(' \
762 halt
='use STREQ_LEN or STRPREFIX instead of str''ncmp' \
765 # Enforce recommended preprocessor indentation style.
766 sc_preprocessor_indentation
:
767 @if cppi
--version
>/dev
/null
2>&1; then \
768 $(VC_LIST_EXCEPT
) | grep
'\.[ch]$$' | xargs cppi
-a
-c \
769 ||
{ echo
'$(ME): incorrect preprocessor indentation' 1>&2; \
772 echo
'$(ME): skipping test $@: cppi not installed' 1>&2; \
775 # THANKS.in is a list of name/email pairs for people who are mentioned in
776 # commit logs (and generated ChangeLog), but who are not also listed as an
777 # author of a commit. Name/email pairs of commit authors are automatically
778 # extracted from the repository. As a very minor factorization, when
779 # someone who was initially listed only in THANKS.in later authors a commit,
780 # this rule detects that their pair may now be removed from THANKS.in.
781 sc_THANKS_in_duplicates
:
782 @
{ git
-C
$(srcdir) log
--pretty
=format
:%aN |
sort -u
; \
783 cut
-b-36
$(srcdir)/THANKS.in \
784 | sed
'/^$$/,/^$$/!d;/^$$/d;s/ *$$//'; } \
785 |
sort | uniq
-d | grep . \
786 && { echo
'$(ME): remove the above names from THANKS.in' \
789 # Ensure the contributor list stays sorted. However, if the system's
790 # en_US.UTF-8 locale data is erroneous, give a diagnostic and skip
791 # this test. This affects OS X, up to at least 10.11.6.
792 # Use our sort as other implementations may result in a different order.
794 @printf
'a\n.b\n'|LC_ALL
=en_US.UTF-8 src
/sort -c
2> /dev
/null \
796 sed
'/^$$/,/^$$/!d;/^$$/d' $(srcdir)/THANKS.in
> $@
.1 && \
797 LC_ALL
=en_US.UTF-8 src
/sort -f
-k1
,1 $@
.1 > $@
.2 && \
798 diff
-u
$@
.1 $@
.2; diff
=$$?
; \
801 ||
{ echo
'$(ME): THANKS.in is unsorted' 1>&2; exit
1; }; \
803 ||
{ echo
'$(ME): this system has erroneous locale data;' \
804 'skipping $@' 1>&2; }
806 # Look for developer diagnostics that are marked for translation.
807 # This won't find any for which devmsg's format string is on a separate line.
808 sc_marked_devdiagnostics
:
809 @prohibit
='$(begword)devmsg *\(.*_\(' \
810 halt
='found marked developer diagnostic(s)' \
813 # Ensure we keep hex constants as 4 or 8 bytes for consistency
814 # and so that make src/fs-magic-compare works consistently
816 @sed
-n
's|.*/\* \(0x[0-9A-Fa-f]\{1,\}\) .*\*/|\1|p' \
817 $(srcdir)/src
/stat.c | grep
-Ev
'^0x([0-9A-F]{4}){1,2}$$' \
818 && { echo
'$(ME): Constants in src/stat.c should be 4 or 8' \
819 'upper-case chars' 1>&2; exit
1; } ||
:
821 # Ensure gnulib generated files are ignored
822 # TODO: Perhaps augment gnulib-tool to do this in lib/.gitignore?
823 sc_gitignore_missing
:
824 @
{ sed
-n
'/^\/lib\/.*\.h$$/{p;p}' $(srcdir)/.gitignore
; \
825 find lib
-name
'*.in*' ! -name
'*~' ! -name
'sys_*' | \
826 sed
's|^|/|; s|_\(.*in\.h\)|/\1|; s/\.in//'; } | \
827 sort | uniq
-u | grep .
&& { echo
'$(ME): Add above' \
828 'entries to .gitignore' >&2; exit
1; } ||
:
830 # Flag redundant entries in .gitignore
831 # Disabled for now as too aggressive flagging
832 # entries like /lib/arg-nonnull.h
833 #sc_gitignore_redundant:
834 # @{ grep ^/lib $(srcdir)/.gitignore; \
835 # sed 's|^|/lib|' $(srcdir)/lib/.gitignore; } | \
836 # sort | uniq -d | grep . && { echo '$(ME): Remove above' \
837 # 'entries from .gitignore' >&2; exit 1; } || :
839 sc_prohibit-form-feed
:
841 in_vc_files
='\.[chly]$$' \
842 halt
='Form Feed (^L) detected' \
845 # Override the default Cc: used in generating an announcement.
846 announcement_Cc_
= $(translation_project_
), \
847 coreutils@gnu.org
, coreutils-announce@gnu.org
849 -include $(srcdir)/dist-check.mk
851 update-copyright-env
= \
852 UPDATE_COPYRIGHT_FORCE
=1 \
853 UPDATE_COPYRIGHT_USE_INTERVALS
=2 \
854 UPDATE_COPYRIGHT_MAX_LINE_LENGTH
=79
856 # List syntax-check exemptions.
857 exclude_file_name_regexp--sc_space_tab
= \
858 ^
(tests
/pr
/|tests
/misc
/nl\.sh
$$|gl
/.
*\.diff
$$|man
/help2man
$$)
859 exclude_file_name_regexp--sc_bindtextdomain
= \
860 ^
(gl
/.
*|lib
/euidaccess-stat|src
/make-prime-list|src
/cksum
)\.c
$$
861 exclude_file_name_regexp--sc_trailing_blank
= \
862 ^
(tests
/pr
/|gl
/.
*\.diff
$$|man
/help2man
)
863 exclude_file_name_regexp--sc_system_h_headers
= \
864 ^src
/((system|copy|chown-core|find-mount-point
)\.h|make-prime-list\.c
)$$
866 _src
= (false|lbracket|ls-
(dir|ls|vdir
)|tac-pipe|uname-
(arch|uname
))
867 _gl_src
= (xdecto.max|cl-strtold
)
868 exclude_file_name_regexp--sc_require_config_h_first
= \
869 (^lib
/buffer-lcm\.c|gl
/lib
/$(_gl_src
)\.c|src
/$(_src
)\.c
)$$
870 exclude_file_name_regexp--sc_require_config_h
= \
871 $(exclude_file_name_regexp--sc_require_config_h_first
)
873 exclude_file_name_regexp--sc_po_check
= ^
(gl
/|man
/help2man
)
874 exclude_file_name_regexp--sc_prohibit_always-defined_macros
= \
875 ^src
/(seq|remove
)\.c
$$
876 exclude_file_name_regexp--sc_prohibit_empty_lines_at_EOF
= ^tests
/pr
/
877 exclude_file_name_regexp--sc_program_name
= \
878 ^
(gl
/.
*|lib
/euidaccess-stat|src
/make-prime-list
)\.c
$$
879 exclude_file_name_regexp--sc_file_system
= \
880 NEWS|^
(init\.cfg|src
/df\.c|tests
/df
/df-P\.sh|tests
/df
/df-output\.sh
)$$
881 exclude_file_name_regexp--sc_prohibit_always_true_header_tests
= \
883 exclude_file_name_regexp--sc_prohibit_fail_0
= \
884 (^.
*/git-hooks
/commit-msg|^tests
/init\.sh|Makefile\.am|\.mk|.
*\.texi
)$$
885 exclude_file_name_regexp--sc_prohibit_test_minus_ao
= doc
/.
*\.texi
$$
886 exclude_file_name_regexp--sc_prohibit_atoi_atof
= ^lib
/euidaccess-stat\.c
$$
888 # longlong.h is maintained elsewhere.
889 _ll
= ^src
/longlong\.h
$$
890 exclude_file_name_regexp--sc_useless_cpp_parens
= $(_ll
)
891 exclude_file_name_regexp--sc_space_before_open_paren
= $(_ll
)
893 tbi_1
= ^tests
/pr
/|
(\.mk|^man
/help2man
)$$
894 tbi_2
= ^scripts
/git-hooks
/(pre-commit|pre-applypatch|applypatch-msg
)$$
895 tbi_3
= (GNU
)?
[Mm
]akefile
(\.am
)?
$$|
$(_ll
)
896 exclude_file_name_regexp--sc_prohibit_tab_based_indentation
= \
897 $(tbi_1
)|
$(tbi_2
)|
$(tbi_3
)
899 exclude_file_name_regexp--sc_preprocessor_indentation
= \
900 ^
(gl
/lib
/rand-isaac\.
[ch
]|gl
/tests
/test-rand-isaac\.c
)$$|
$(_ll
)
901 exclude_file_name_regexp--sc_prohibit_stat_st_blocks
= \
902 ^
(src
/system\.h|tests
/du
/2g\.sh
)$$
904 exclude_file_name_regexp--sc_prohibit_continued_string_alpha_in_column_1
= \
905 ^src
/(system\.h|od\.c|printf\.c|getlimits\.c
)$$
907 _cksum
= ^tests
/cksum
/cksum-base64\.pl
$$
908 exclude_file_name_regexp--sc_prohibit_test_backticks
= \
909 ^tests
/(local\.mk|
(init|misc
/stdbuf|factor
/create-test
)\.sh
)$$|
$(_cksum
)
911 # Exempt test.c, since it's nominally shared, and relatively static.
912 exclude_file_name_regexp--sc_prohibit_operator_at_end_of_line
= \
913 ^src
/(ptx|
test|head
)\.c
$$
915 exclude_file_name_regexp--sc_error_message_uppercase
= ^src
/factor\.c
$$
916 exclude_file_name_regexp--sc_prohibit_atoi_atof
= ^src
/make-prime-list\.c
$$
918 # Exception here as we don't want __attribute elided on non GCC
919 exclude_file_name_regexp--sc_prohibit-gl-attributes
= ^src
/libstdbuf\.c
$$
921 exclude_file_name_regexp--sc_prohibit_uppercase_id_est
= \.diff
$$
922 exclude_file_name_regexp--sc_ensure_dblspace_after_dot_before_id_est
= \.diff
$$
923 exclude_file_name_regexp--sc_ensure_comma_after_id_est
= \.diff|
$(_ll
)$$
924 exclude_file_name_regexp--sc_long_lines
= \.diff
$$|
$(_ll
)|
$(_cksum
)
926 # `grep . -q` is not exactly equivalent to `grep . >/dev/null`
927 # and this difference is significant in the NEWS description
928 exclude_file_name_regexp--sc_unportable_grep_q
= NEWS
930 # Augment AM_CFLAGS to include our per-directory options:
931 AM_CFLAGS
+= $($(@D
)_CFLAGS
)
933 src_CFLAGS
= $(WARN_CFLAGS
)
934 lib_CFLAGS
= $(GNULIB_WARN_CFLAGS
)
935 gnulib-tests_CFLAGS
= $(GNULIB_TEST_WARN_CFLAGS
)
937 # Configuration to make the tight-scope syntax-check rule work with
938 # non-recursive make.
939 # Note _gl_TS_headers use _single line_ extern function declarations,
940 # while *_SOURCES use the _two line_ form.
941 export _gl_TS_headers
= $(noinst_HEADERS
)
942 # Add exceptions for --enable-single-binary renamed functions.
943 _gl_TS_unmarked_extern_functions
= main usage
944 _gl_TS_unmarked_extern_functions
+= single_binary_main_.
* _usage_.
*
945 # Headers to search for single line extern _data_ declarations.
946 _gl_TS_other_headers
= $(srcdir)/src
/*.h src
/*.h
947 # Tell the tight_scope rule about an exceptional "extern" variable.
948 # Normally, the rule would detect its declaration, but that uses a
949 # different name, __clz_tab.
950 _gl_TS_unmarked_extern_vars
= factor_clz_tab
951 # Other tight_scope settings
953 _gl_TS_obj_files
= src
/*.
$(OBJEXT
)